<template>
    <div class="content__leftAnalitika">
        <div class="add-news">
            <div class="add__news--list ">
                <h2 class="title-list  wow fadeInLeft">{{ $t('posts.table.title') }}</h2>
                <div class="box-table--title  wow fadeInUp">
                    <p class="text-elementTitle">{{ $t('posts.table.date') }}</p>
                    <p class="text-elementTitle">{{ $t('posts.table.name') }}</p>
                    <p class="text-elementTitle">{{ $t('posts.table.description') }}</p>
                    <p class="text-elementTitle">{{ $t('posts.table.image') }}</p>
                </div>
                <post v-for="post in posts" :post="post" :key="post.id" @delete-post="deletePost" @updated="postUpdated"/>
                <paginator
                    :current-page="currentPage"
                    :last-page="lastPage"
                    :per-page="perPage"
                    :items-count="total"
                    @page-changed="setPage"
                />
            </div>
        </div>
    </div>
</template>

<script>
import route from "../mixins/route";
import {mapGetters} from "vuex";
import Post from "../components/posts/Post";

export default {
        name: "Posts",
        mixins: [route],
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                posts: [],
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        methods: {
            submit(){
                this.axios.get(`posts`, {
                    params: {
                        page: this.page,
                    }
                })
                    .then(resp => resp.data)
                    .then(posts => {
                        console.log(posts);
                        this.currentPage = posts.current_page;
                        this.lastPage = posts.last_page;
                        this.perPage = posts.per_page;
                        this.total = posts.total;
                        this.posts = posts.data;
                    });
            },
            deletePost(id){
                this.axios
                    .post(`posts/${id}/delete`)
                    .then(resp => resp.data)
                    .then(data => {
                        if('success' === data.status){
                            this.$swal('Новость удалена');
                            this.submit();
                        }else{
                            this.$swal(this.$t('ui.error'), '', 'error')
                        }
                    });
            },
			postUpdated(post){
				console.log(post);
				let index = this.posts.findIndex((value) => value.id === post.id);
				console.log(index);
				let deleted = this.posts.splice(index, 1, post);
				console.log(deleted);
			},
            setPage(page){
                this.page = page;
                this.submit();
            },
            formatDate(date){
                return this.$date(date).format('DD.MM.YYYY');
            },
            formatTime(date){
                return this.$date(date).format('HH:mm:ss');
            }
        },
        components: {
            Post
        },
        mounted(){
            this.submit();
        },
    }
</script>

<style scoped>

</style>
